<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="oxy-allows-child-element">
  <title>oxy:allows-child-element() Function</title>
  <prolog>
    <metadata>
      <keywords>
        <indexterm>oxy:allows-child-element function</indexterm>
      </keywords>
    </metadata>
  </prolog>
  <body>
    <p id="p_ac4_bgk_54b">The <b>oxy:allows-child-element()</b> function allows you to check whether or not an element
      that matches the arguments of the function is valid as a child of the element at the current
      cursor position, according to the associated schema. It is evaluated at the cursor position
      and has the following signature:</p>
    <p id="p_bc4_bgk_54b"><b><codeph>oxy:allows-child-element($childName, ($attributeName, $defaultAttributeValue,
          $contains?)?)</codeph></b></p>
    <p id="p_cc4_bgk_54b">The following parameters are supported:<parml>
        <plentry>
          <pt><codeph>childName</codeph></pt>
          <pd>The name of the element that you want to check if it is valid in the current context.
            Its value is a string that supports the following forms:<ul id="ul_dc4_bgk_54b">
              <li id="li_ec4_bgk_54b">
                <p id="p_fc4_bgk_54b">The child element with the specified local name that belongs to the default
                  namespace.<codeblock  id="codeblock_gc4_bgk_54b">oxy:allows-child-element("para")</codeblock></p>
                <p id="p_hc4_bgk_54b">The above example verifies if the <xmlelement>para</xmlelement> element (of the
                  default namespace) is allowed in the current context.</p>
              </li>
              <li id="li_ic4_bgk_54b">
                <p id="p_jc4_bgk_54b">The child element with the local name specified by any
                  namespace.<codeblock  id="codeblock_kc4_bgk_54b">oxy:allows-child-element("*:para")</codeblock></p>
                <p id="p_lc4_bgk_54b">The above example verifies if the <xmlelement>para</xmlelement> element (of any
                  namespace) is allowed in the current context.</p>
              </li>
              <li id="li_mc4_bgk_54b">
                <p id="p_nc4_bgk_54b">A prefix-qualified name of an
                  element.<codeblock  id="codeblock_oc4_bgk_54b">oxy:allows-child-element("prefix:para")</codeblock></p>
                <p id="p_pc4_bgk_54b">The prefix is resolved in the context of the element where the cursor is located.
                  The function matches on the element with the <codeph>para</codeph> local name from
                  the previously resolved namespace. If the prefix is not resolved to a namespace,
                  the function returns a value of <codeph>false</codeph>.</p>
              </li>
              <li id="li_qc4_bgk_54b">
                <p id="p_rc4_bgk_54b">A specified namespace-URI-qualified name of an
                  element.<codeblock  id="codeblock_sc4_bgk_54b">oxy:allows-child-element("{namespaceURI}para")</codeblock></p>
                <p id="p_tc4_bgk_54b">The <codeph>namespaceURI</codeph> is the namespace of the element. The above
                  example verifies if the <xmlelement>para</xmlelement> element (of the specified
                  namespace) is allowed in the current context.</p>
              </li>
              <li id="li_uc4_bgk_54b">
                <p id="p_vc4_bgk_54b">Any
                  element.<codeblock  id="codeblock_wc4_bgk_54b">oxy:allows-child-element("*")</codeblock></p>
                <p id="p_xc4_bgk_54b">The above function verifies if any element is allowed in the current
                    context.<note id="note_yc4_bgk_54b">A common use case of
                      <codeph>oxy:allows-child-element("*")</codeph> is in combination with the
                      <codeph>attributeName</codeph> parameter.</note></p>
              </li>
            </ul></pd>
        </plentry>
        <plentry>
          <pt><codeph>attributeName</codeph></pt>
          <pd>The attribute of an element that you want to check if it is valid in the current
            context. Its value is a string that supports the following forms:<ul id="ul_zc4_bgk_54b">
              <li id="li_ad4_bgk_54b">
                <p id="p_bd4_bgk_54b">The attribute with the specified name from no
                  namespace.<codeblock  id="codeblock_cd4_bgk_54b">oxy:allows-child-element("*", "class", " topic/topic ")</codeblock></p>
                <p id="p_dd4_bgk_54b">The above example verifies if an element with the <xmlatt>class</xmlatt>
                  attribute and the default value of this attribute (that contains the
                    <codeph>topic/topic</codeph> string) is allowed in the current context.</p>
              </li>
              <li id="li_ed4_bgk_54b">The attribute with the local name specified by any
                namespace.<codeblock  id="codeblock_fd4_bgk_54b">oxy:allows-child-element("*", "*:localname", " topic/topic ")</codeblock></li>
              <li id="li_gd4_bgk_54b">
                <p id="p_hd4_bgk_54b">A qualified name of an
                  attribute.<codeblock  id="codeblock_id4_bgk_54b">oxy:allows-child-element("*", "prefix:localname", " topic/topic ")</codeblock></p>
                <p id="p_jd4_bgk_54b">The prefix is resolved in the context of the element where the cursor is located.
                  If the prefix is not resolved to a namespace, the function returns a value of
                    <codeph>false</codeph>.</p>
              </li>
            </ul></pd>
        </plentry>
        <plentry>
          <pt><codeph>defaultAttributeValue</codeph></pt>
          <pd>A string that represents the default value of the attribute. Depending on the value of
            the next parameter, the default value of the attribute must either contain this value or
            be equal to it.</pd>
        </plentry>
        <plentry>
          <pt><codeph>contains</codeph></pt>
          <pd>An optional boolean. The default value is <codeph>true</codeph>. For the
              <codeph>true</codeph> value, the default value of the attribute must contain the
              <codeph>defaultAttributeValue</codeph> parameter. If the value is
              <codeph>false</codeph>, the two values must be the same.</pd>
        </plentry>
      </parml></p>
  </body>
</topic>
